﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FM6000_Listview {
    /// <summary>
    /// Interaction logic for FProgInfo.xaml
    /// </summary>
    public partial class FProgInfo : Window {

        public FProgInfo(Window parent) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner            
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            var version = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
            int major = version.Major;
            int minor = version.Minor;
            int build = version.Build;
            int revision = version.Revision;

            labelVersion.Content= "Version: 08.09.2018";

            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Computername: " + System.Environment.MachineName);
            sb.AppendLine("BS-Version: " + System.Environment.OSVersion);
            sb.AppendLine("Version: " + System.Environment.Version);
            if (System.Environment.Is64BitOperatingSystem)
                sb.AppendLine("64-Bit-Version:");
            else
                sb.AppendLine("32-Bit-Version:");
            sb.AppendLine("Benutzername: " + System.Environment.UserName);
            sb.AppendLine("Anzahl der CPU's: " + System.Environment.ProcessorCount);
            this.textBoxDescription1.Text = sb.ToString();
            textBoxDescription1.SelectionStart = 0;

        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
        }



    }
}
