﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FM6000_Listview {
    /// <summary>
    /// Interaction logic for FReadFavorit.xaml
    /// </summary>
    public partial class FReadFavorit : Window {

        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }

        public String Bez {
            get { return tBez.Text.Trim(); }
        }
        public String Path {
            get { return tPath.Text.Trim(); }
        }

        public FReadFavorit(Window parent, String bez, String path) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner            
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            tBez.Text = bez;
            tPath.Text = path;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {

        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (tBez.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Bezeichnung ein", "Hinweis");
                tBez.Focus();
                return;
            }
            if (tPath.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte ein Verzeichnis ein", "Hinweis");
                tPath.Focus();
                return;
            }
            if (!Directory.Exists(tPath.Text.Trim())) {
                Basis.ErrorMsg("Das Verzeichnis existiert nicht", "Hinweis");
                tPath.Focus();
                return;
            }
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        // KeyDown="Window_KeyDown"
        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

        // externer Verweis eintragen
        // ProjektTree, Verweis,  Register .net  System.Windows.Forms
        private void bnSelectFolder_Click(object sender, RoutedEventArgs e) {
            System.Windows.Forms.FolderBrowserDialog dialog = new System.Windows.Forms.FolderBrowserDialog();
            System.Windows.Forms.DialogResult result = dialog.ShowDialog();
            if (result == System.Windows.Forms.DialogResult.OK) {
                tPath.Text = dialog.SelectedPath;
            }
        }


    }
}
