﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using System.IO;

namespace FM6000_Listview {
    /// <summary>
    /// Interaction logic for FReadProg.xaml
    /// </summary>
    public partial class FReadProg : Window {
        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }

        public String Bez {
            get { return tBez.Text.Trim(); }
        }
        public String Prog {
            get { return tProg.Text.Trim(); }
        }

        public FReadProg(Window parent, String bez, String path) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner     
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            tBez.Text = bez;
            tProg.Text = path;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {

        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (tBez.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Bezeichnung ein", "Hinweis");
                tBez.Focus();
                return;
            }
            if (tProg.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte ein Verzeichnis ein", "Hinweis");
                tProg.Focus();
                return;
            }
            if (!File.Exists(tProg.Text.Trim())) {
                Basis.ErrorMsg("Das Programm existiert nicht", "Hinweis");
                tProg.Focus();
                return;
            }
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

        // externer Verweis eintragen
        // ProjektTree, Verweis,  Register .net  System.Windows.Forms
        private void bnSelectFile_Click(object sender, RoutedEventArgs e) {
            System.Windows.Forms.OpenFileDialog openFileDialog = new System.Windows.Forms.OpenFileDialog();
            openFileDialog.InitialDirectory = Environment.CurrentDirectory;
            openFileDialog.Filter = "Programm (*.exe)|*.exe|Word-Dateien (*.doc?)|*.doc?|Excel-Dateien (*.xls?)|*.xls?|Alle Dateien (*.*)|*.*";
            if (openFileDialog.ShowDialog(null) == System.Windows.Forms.DialogResult.OK) {
                tProg.Text = openFileDialog.FileName;
            }
        } // bnSelectFile_Click

    }
}
