﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FM6000_Listview {
    /// <summary>
    /// Interaction logic for FReadRenameWithNumbers.xaml
    /// </summary>
    public partial class FReadRenameWithNumbers : Window {

        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String Prefix {
            get { return tPrefix.Text.Trim(); }
        }
        int countNumbers = 0;
        public int CountNumbers {
            get { return countNumbers; }
        }

        public FReadRenameWithNumbers(Window parent) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner      
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tPrefix.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (tPrefix.Text.Trim().Length==0) {
                tPrefix.Focus();
                Basis.ErrorMsg("Bitte geben Sie einen Prefix ein", "Hinweis");
                return;
            }
            if (tCountNumbers.Text.Trim().Length == 0) {
                tCountNumbers.Focus();
                Basis.ErrorMsg("Bitte geben Sie die Anzahl der Ziffern ein", "Hinweis");
                return;
            }
            if (!int.TryParse(tCountNumbers.Text.Trim(), out countNumbers)) {
                tCountNumbers.Focus();
                Basis.ErrorMsg("Bitte geben Sie eine Zahl ein", "Hinweis");
                return;
            }
            if (countNumbers<0 || countNumbers>5) {
                tCountNumbers.Focus();
                Basis.ErrorMsg("Bitte geben Sie eine Zahl zwischen 1 und 5 ein", "Hinweis");
                return;
            }
            
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

    }
}
