﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


using System.IO;

namespace FM6000_Listview {
    /// <summary>
    /// Interaction logic for FShowDriveSpace.xaml
    /// </summary>
    public partial class FShowDriveSpace : Window {

        private String _lw = "";

        public FShowDriveSpace(Window parent, String lw) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner    
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            _lw = lw;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            setGUI();
        }

        private void setGUI() {
            DriveInfo[] drives = DriveInfo.GetDrives();
            int index = -1;
            foreach (DriveInfo drv in drives) {
                String typ = "";
                // check, if node1 ist drive c ?
                switch (drv.DriveType) {
                    case DriveType.CDRom: typ = "CD/DVD:"; break;
                    case DriveType.Fixed: typ = "Platte:"; break;
                    case DriveType.Network: typ = "Netz:"; break;
                    case DriveType.Ram: typ = "Ram:"; break;
                    case DriveType.Removable: typ = "USB:"; break;
                    case DriveType.Unknown: typ = "?:"; break;
                }
                DrivesProperty frame = new DrivesProperty();
                String header;
                double free;
                if (drv.IsReady) {
                    frame.ldrive2.Content = drv.Name;
                    frame.lBez.Content = drv.VolumeLabel;
                    frame.lTyp2.Content = typ;
                    frame.lfilessystem2.Content = drv.DriveFormat;

                    frame.lClustersize2.Content = Basis.Long_Str_Komma(Basis.GetCluster(drv.Name)) + " Bytes";

                    frame.lgesamt2.Content = Basis.Long_Str_Komma(drv.TotalSize) + " Bytes";
                    frame.lgesamt3.Content = Basis.Best_KB(drv.TotalSize);
                    frame.lfreier2.Content = Basis.Long_Str_Komma(drv.AvailableFreeSpace) + " Bytes";
                    frame.lfreier3.Content = Basis.Best_KB(drv.AvailableFreeSpace);
                    frame.lbelegt2.Content = Basis.Long_Str_Komma(drv.TotalSize - drv.AvailableFreeSpace) + " Bytes";
                    frame.lbelegt3.Content = Basis.Best_KB(drv.TotalSize - drv.AvailableFreeSpace);
                    free = (double)drv.AvailableFreeSpace / drv.TotalSize;

                    GradientStopCollection gc = new GradientStopCollection();

                    gc.Add(new GradientStop(Colors.Red, 0));
                    gc.Add(new GradientStop(Colors.Green, 0));
                    LinearGradientBrush brush = new LinearGradientBrush(gc, new Point(free, 0), new Point(0, 0));
                    frame.bar.Fill = brush;
                    header = drv.Name + " (" + drv.VolumeLabel + ")";
                }
                else {
                    header = drv.Name;
                    frame.ldrive2.Content = drv.Name;
                    frame.lBez.Content = "";
                    frame.lTyp2.Content = typ;
                    frame.lfilessystem2.Content = "";
                    frame.lClustersize2.Content = "0 Bytes";
                    frame.lgesamt2.Content = "0 Bytes";
                    frame.lgesamt3.Content = "0 Bytes";
                    frame.lfreier2.Content = "0 Bytes";
                    frame.lfreier3.Content = "0 Bytes";
                    frame.lbelegt2.Content = "0 Bytes";
                    frame.lbelegt3.Content = "0 Bytes";
                    free = 0;

                    GradientStopCollection gc = new GradientStopCollection();

                    gc.Add(new GradientStop(Colors.Red, 0));
                    gc.Add(new GradientStop(Colors.Green, 0));
                    LinearGradientBrush brush = null; //  new LinearGradientBrush(gc, new Point(free, 0), new Point(0, 0));
                    frame.bar.Fill = brush;
                }
                TabItem tabitem = new TabItem();
                tabitem.Header = header;
                tabitem.Content = frame;
                tabControl1.Items.Add(tabitem);
                if (drv.Name.Equals(_lw)) {
                    index = tabControl1.Items.Count - 1;
                }
            } // foreach
            if (index >= 0) {
                tabControl1.SelectedIndex = index;
            }
        }  // setgUI

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }
    }
}
