using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ComponentModel;
using System.Windows.Media;
using System.IO;  // Sortieren SortDescriptions

//   IComparable<FileItem> 

namespace FM6000_Listview{
    public class FileItem  {
        public enum FileinfoTyp { Name, Ext, LastTime, Size };

        public static FileinfoTyp sortType = FileinfoTyp.Name;
        public static ListSortDirection direction = ListSortDirection.Ascending;

        private String fullname = "";
        private String filename = "";
        private String ext = "";
        private DateTime createTime;
        private DateTime lastTime; 
        private long size = 0;
        private bool directory = false;
        private ImageSource iconUri = null;


        public FileItem(FileItem fileItem) {
            fullname = fileItem.Fullname;
            filename = fileItem.Filename;
            ext = fileItem.Ext;
            createTime = fileItem.CreateTime;
            lastTime = fileItem.LastTime;
            size = fileItem.Size;
            directory = fileItem.Directory;
            iconUri = fileItem.IconUri;
        }
        // public string Fullname { get; set; }

        public FileItem(bool directory) {
            this.directory = directory;
        }


        public String Fullname {
            get { return fullname; }
            set { fullname = value; }
        }
        public String Filename {
            get { return filename; }
            set { filename = value; }
        }
        public String Ext {
            get {
                if (ext.Length == 0)
                    return "";
                else
                    return ext.Substring(1).ToUpper();
            }
            set { ext = value; }
        }
        public String StringSize {
            get {
                if (size == 0)
                    return "";
                else
                    return Basis.Long_Str_Komma(size);
            }
        }
        public long Size {
            get { return size; }
            set { size = value; }
        }
        public DateTime CreateTime {
            get { return createTime; }
            set { createTime = value; }
        }
        public DateTime LastTime {
            get { return lastTime; }
            set { lastTime = value; }
        }
        public bool Directory {
            get { return directory; }
            set { directory = value; }
        }
        public String DirectoryAsString {
            get {
                if (directory)
                    return "Dir";
                else
                    return "";
            }
        }

        public ImageSource IconUri {
            get {
                return iconUri;
            }
            set { iconUri = value; }
        }

        public void ChangeExtention(String newExtention) {
            if (!newExtention.StartsWith(".")) newExtention = "." + newExtention;
            int i = fullname.LastIndexOf('.');
            if (i >= 0) {
                String newFullname = fullname.Substring(0, i - 1) + newExtention;
                System.IO.File.Move(fullname, newFullname);
                
            }
            //String filename = "";
            //String ext = "";
        }

        public void RenameWithNumbers(String prefix, String sNumbers) {
            String path;
            int i;
            i = fullname.LastIndexOf('.');
            if (i >= 0) {
                path = Basis.getPath(fullname);  // with \\
                String newFullname = path + prefix + sNumbers+ext;
                System.IO.File.Move(fullname, newFullname);
            }
            else {
            }
        }


    }
}
