﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FM6000_Listview {
    public class FileItemComparer : System.Collections.IComparer {


        public int Compare(Object obj1, Object obj2) {
            FileItem a = (FileItem) obj1;
            FileItem b = (FileItem)obj2;
            int retcode = 0;
            if (a.Directory && !b.Directory) {
                // I'm am a directory, the param not
                return -1;
            }
            else {
                if (!a.Directory && b.Directory) {
                    // I'm am not a directory, the param is a directoy
                    return +1;
                }
                else {
                    // I'm am a directory, the param is also a directoy
                    if (a.Directory && b.Directory) {
                        if (a.Filename.Equals(Konstanten.C_TOP_DIR)) return -1;
                        if (b.Filename.Equals(Konstanten.C_TOP_DIR)) return +1;
                        switch (FileItem.sortType) {
                            case FileItem.FileinfoTyp.Name: retcode = a.Filename.CompareTo(b.Filename); break;
                            case FileItem.FileinfoTyp.Ext: retcode = a.Ext.CompareTo(b.Ext); break;
                            case FileItem.FileinfoTyp.LastTime: retcode = a.LastTime.CompareTo(b.LastTime); break;
                            case FileItem.FileinfoTyp.Size: retcode = 0; break;
                        }
                    }
                    else {
                        // I'm am not a directory, the param is also not a directoy
                        switch (FileItem.sortType) {
                            case FileItem.FileinfoTyp.Name: retcode = a.Filename.CompareTo(b.Filename); break;
                            case FileItem.FileinfoTyp.Ext: retcode = a.Ext.CompareTo(b.Ext); break;
                            case FileItem.FileinfoTyp.LastTime: retcode = a.LastTime.CompareTo(b.LastTime); break;
                            case FileItem.FileinfoTyp.Size: retcode = a.Size.CompareTo(b.Size); break;
                        }
                    }
                    // if the sort is ascending, multiplication with -1
                    if (FileItem.direction != ListSortDirection.Ascending)
                        retcode = -retcode;
                }
            }
            return retcode;
        }


    }
}
