using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;



using System.Windows.Controls;
using System.Collections;
using System.IO;  // neu

namespace FM6000_Listview{
    public class Middleware {

        private static Middleware _instance = new Middleware();

        private Middleware() {
        }


        public static Middleware getInstance() {
            return _instance;
        }

        public enum Masken { Stern, ppt, java, txt, doc, xls, pdf, doku, exe, ownerdef }


        //public List<FileItem> _edit_fileliste = new List<FileItem>();
        //public String _actionFileString = "";

        //public FileOperationAPIWrapper.FileOperationType _fileop = FileOperationAPIWrapper.FileOperationType.FO_COPY;

        // call from UListView, method insertSelectedFiles
        public void insertSelectedFiles(ArrayList liste, ThreadCopyDeleteMove.FileOperationType action) {
            Basis.WriteRegInt(Konstanten.C_REG_ADR + "\\FileOp", "FileOperationType", (int)action);  // nur Strg+C  oder Strg+X
            Basis.WriteRegInt(Konstanten.C_REG_ADR + "\\FileOp", "AnzFiles", liste.Count);
            for (int i = 0; i < liste.Count; i++) {
                String item = (String)liste[i];
                    Basis.WriteRegString(Konstanten.C_REG_ADR + "\\FileOp", "File" + i, item);
            }
        }
        public int getSelectedFilesFromRegistry(out String actionFileString) {
            String item;
            int action = Basis.ReadRegInt(Konstanten.C_REG_ADR + "\\FileOp", "FileOperationType");  // nur Strg+C  oder Strg+X
            int anz = Basis.ReadRegInt(Konstanten.C_REG_ADR + "\\FileOp", "AnzFiles");
            StringBuilder files = new StringBuilder();
            for (int i = 0; i < anz; i++) {
                item = Basis.ReadRegString(Konstanten.C_REG_ADR + "\\FileOp", "File" + i);
                files.Append(item).Append("\0");
            }
            actionFileString = files.ToString();
            return action;
        }


        public static void readTexte(String path, String filename, bool isDir, ref ArrayList liste) {
            int i;
            Favorit f;
            //path = Directory.GetCurrentDirectory(); //System.Environment.CurrentDirectory;
            // path = System.Environment.CurrentDirectory;
            if (File.Exists(path + filename)) {
                String[] items = File.ReadAllLines(path + filename);
                i = 0;
                while (i < items.Length) {
                    if (items[i].Length > 0) {
                        bool ok;
                        if (isDir)
                            ok = Directory.Exists(items[i + 1]);
                        else
                            ok = File.Exists(items[i + 1]);
                        if (!ok) {
                            Basis.ErrorMsg("Der Eintrag ist nicht vorhanden\r\n" + items[i + 1], "Eintragen der Favoriten-Verzeichnisse");
                            i += 2;
                        }
                        else {
                            f = new Favorit();
                            f.Bez = items[i];
                            i++;
                            f.Path = items[i];
                            i++;
                            liste.Add(f);
                        }
                    }
                    else {
                        i++;
                        i++;
                    }
                }
            }
        }


        public static bool checkFile(Masken aktmask, String OwnerDefined, String filename) {
            bool ok = false;
            if (aktmask != Masken.Stern) {
                int index = filename.LastIndexOf(".");
                if (index >= 0) {
                    String ext = filename.Substring(index + 1).ToLower();
                    String[] masken = null;
                    if (aktmask == Masken.ownerdef) {
                        if (OwnerDefined.IndexOf(';') >= 0)
                            masken = OwnerDefined.Split(';');
                        else {
                            masken = new String[1];
                            masken[0] = OwnerDefined;
                        }
                    }
                    else {
                        switch (aktmask) {
                            case Masken.java: masken = new String[] { "java" };
                                break;
                            case Masken.ppt: masken = new String[] { "ppt", "pptx" };
                                break;
                            case Masken.doc: masken = new String[] { "doc", "docx" };
                                break;
                            case Masken.xls: masken = new String[] { "xls", "xlsx" };
                                break;
                            case Masken.txt: masken = new String[] { "txt" };
                                break;
                            case Masken.pdf: masken = new String[] { "pdf" };
                                break;
                            case Masken.exe: masken = new String[] { "exe" };
                                break;
                            case Masken.doku: masken = new String[] { "doc", "docx", "xls", "xlsx", "ppt", "pptx", "pdf" };
                                break;
                            default: Basis.ErrorMsg("Fehlerhafter Eintrag in switch/case\r\n", "Methode checkFile");
                                break;
                        } // case
                    }  //if (_aktmask == Masken.ownerdef) {
                    foreach (String mask in masken) {
                        ok |= ext.Equals(mask.Trim());
                    }
                } // if (index >= 0) {
            }  // if (_aktmask != Masken.Stern) {
            else {
                ok = true;
            }
            return ok;
        }  // checkFile


        public static String[] getMasks(Masken aktmask, String OwnerDefined) {
            String[] masken = null;
            if (aktmask != Masken.Stern) {
                if (aktmask == Masken.ownerdef) {
                    if (OwnerDefined.IndexOf(';') >= 0)
                        masken = OwnerDefined.Split(';');
                    else {
                        masken = new String[1];
                        masken[0] = OwnerDefined;
                    }
                }
                else {
                    switch (aktmask) {
                        case Masken.java: masken = new String[] { "*.java" };
                            break;
                        case Masken.ppt: masken = new String[] { "*.ppt", "*.pptx" };
                            break;
                        case Masken.doc: masken = new String[] { "*.doc", "*.docx" };
                            break;
                        case Masken.xls: masken = new String[] { "*.xls", "*.xlsx" };
                            break;
                        case Masken.txt: masken = new String[] { "*.txt" };
                            break;
                        case Masken.pdf: masken = new String[] { "*.pdf" };
                            break;
                        case Masken.exe: masken = new String[] { "*.exe" };
                            break;
                        case Masken.doku: masken = new String[] { "*.doc", "*.docx", "*.xls", "*.xlsx", "*.ppt", "*.pptx", "*.pdf" };
                            break;
                        default: Basis.ErrorMsg("Fehlerhafter Eintrag in switch/case\r\n", "Methode checkFile");
                            break;
                    } // case
                }  //if (_aktmask == Masken.ownerdef) {
            }
            else {
                masken = new String[] { "*.*" };
            }
            return masken;
        }  // checkFile

    }
}
