﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Windows.Input;


namespace FM6000_Listview {
    public class MyCommands {


        private static RoutedUICommand newFolder;
        private static RoutedUICommand loadAgain;

        private static RoutedUICommand showAllFiles;
        private static RoutedUICommand compareFolders;



        private static RoutedUICommand path2Clipboard;
        private static RoutedUICommand ownerDefinedMask;
        private static RoutedUICommand showAllFile;

        private static RoutedUICommand copy;
        private static RoutedUICommand paste;
        private static RoutedUICommand cut;
        private static RoutedUICommand selectall;
        private static RoutedUICommand delete;

        private static RoutedUICommand deleteTab;
        private static RoutedUICommand newRegister;
        private static RoutedUICommand newRegisterWithPath;

        private static RoutedUICommand renameF2;
        private static RoutedUICommand copyF8;

        private static RoutedUICommand goToTopFolder;
        private static RoutedUICommand goToRoot;

        private static RoutedUICommand newInstanz;
        private static RoutedUICommand close;

        private static RoutedUICommand dosEbene;

        private static RoutedUICommand runNotepad;

        private static RoutedUICommand loadDrivesAgain;
        private static RoutedUICommand runEditor5000;
        private static RoutedUICommand runHexEditor;

        private static RoutedUICommand options;
        private static RoutedUICommand progInfo;


        static MyCommands() {


            newFolder = new RoutedUICommand("Neuer Ordner", "newFolder", typeof(MyCommands));
            newFolder.InputGestures.Add(new KeyGesture(Key.Insert, ModifierKeys.None));

            path2Clipboard = new RoutedUICommand("Kompletter Pfad in die Zwischenablage", "path2Clipboard", typeof(MyCommands));
            path2Clipboard.InputGestures.Add(new KeyGesture(Key.K, ModifierKeys.Control));

            loadAgain = new RoutedUICommand("Neu _Einlesen", "loadAgain", typeof(MyCommands));
            loadAgain.InputGestures.Add(new KeyGesture(Key.F5, ModifierKeys.None));


            showAllFiles = new RoutedUICommand("Bestimmen aller Dateien (Rekursiv)", "ShowAllFiles", typeof(MyCommands));
            compareFolders = new RoutedUICommand("Vergleich zweier Verzeichnisse", "compareFolders", typeof(MyCommands));

            copy = new RoutedUICommand("Kopieren", "Copy", typeof(MyCommands));
            copy.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Control));

            paste = new RoutedUICommand("Einfügen", "Paste", typeof(MyCommands));
            paste.InputGestures.Add(new KeyGesture(Key.V, ModifierKeys.Control));

            cut = new RoutedUICommand("Ausschneiden", "Cut", typeof(MyCommands));
            cut.InputGestures.Add(new KeyGesture(Key.X, ModifierKeys.Control));


            delete = new RoutedUICommand("Löschen", "delete", typeof(MyCommands));


            copyF8 = new RoutedUICommand("Kopieren", "Copy", typeof(MyCommands));
            copyF8.InputGestures.Add(new KeyGesture(Key.F8, ModifierKeys.None));

            renameF2 = new RoutedUICommand("Datei umbenennen", "renameF2", typeof(MyCommands));
            renameF2.InputGestures.Add(new KeyGesture(Key.F2, ModifierKeys.None));

            ownerDefinedMask = new RoutedUICommand("_selbst. def. Maske", "ownerDefined", typeof(MyCommands));
            ownerDefinedMask.InputGestures.Add(new KeyGesture(Key.F4, ModifierKeys.None));

            showAllFile = new RoutedUICommand("*.*", "showAllFile", typeof(MyCommands));
            

            selectall = new RoutedUICommand("Alles markieren", "selectall", typeof(MyCommands));
            selectall.InputGestures.Add(new KeyGesture(Key.A, ModifierKeys.Control));


            deleteTab = new RoutedUICommand("Löschen des aktuellen Registers", "deleteTab", typeof(MyCommands));
            deleteTab.InputGestures.Add(new KeyGesture(Key.F4, ModifierKeys.Control));

            newRegister = new RoutedUICommand("Neues Register", "newRegister", typeof(MyCommands));
            newRegister.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control));

            newRegisterWithPath = new RoutedUICommand("Neues Register mit dem aktuellen Pfad", "newRegisterWithPath", typeof(MyCommands));
            // newRegisterWithPath.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control));


            goToTopFolder = new RoutedUICommand("Sprung zum oberen Verzeichnis", "goToTopFolder", typeof(MyCommands));
            goToRoot = new RoutedUICommand("Sprung zum Root", "goToRoot", typeof(MyCommands));

            newInstanz = new RoutedUICommand("Neue Instanz", "newInstanz", typeof(MyCommands));

            close = new RoutedUICommand("Schließen", "close", typeof(MyCommands));

            dosEbene = new RoutedUICommand("Dos-Ebene im aktuellen Verzeichnis", "dosEbene", typeof(MyCommands));
            dosEbene.InputGestures.Add(new KeyGesture(Key.D, ModifierKeys.Control));

            runNotepad = new RoutedUICommand("Aktuelle Datei in Notepad", "runNotepad", typeof(MyCommands));
            runNotepad.InputGestures.Add(new KeyGesture(Key.F12, ModifierKeys.None));


            options = new RoutedUICommand("Optionen", "options", typeof(MyCommands));

            progInfo = new RoutedUICommand("Programm-Info", "progInfo", typeof(MyCommands));

            loadDrivesAgain = new RoutedUICommand("Neu _Einlesen", "loadAgain", typeof(MyCommands));
            loadDrivesAgain.InputGestures.Add(new KeyGesture(Key.F5, ModifierKeys.Control));

            runEditor5000 = new RoutedUICommand("Aktuelle Datei in Editor5000", "runEditor5000", typeof(MyCommands));
            runEditor5000.InputGestures.Add(new KeyGesture(Key.F11, ModifierKeys.None));

            runHexEditor = new RoutedUICommand("Aktuelle Datei in einem Hex-Editor", "runHexEditor", typeof(MyCommands));
            runHexEditor.InputGestures.Add(new KeyGesture(Key.F12, ModifierKeys.Control));

        }


        public static RoutedUICommand NewFolder {
            get { return newFolder; }
        }

        public static RoutedUICommand Path2Clipboard {
            get { return path2Clipboard; }
        }



        public static RoutedUICommand LoadAgain {
            get { return loadAgain; }
        }

        public static RoutedUICommand ShowAllFiles {
            get { return showAllFiles; }
        }

        public static RoutedUICommand CompareFolders {
            get { return compareFolders; }
        }


        public static RoutedUICommand Copy {
            get { return copy; }
        }
        public static RoutedUICommand Paste {
            get { return paste; }
        }
        public static RoutedUICommand Cut {
            get { return cut; }
        }


        public static RoutedUICommand Delete {
            get { return delete; }
        }

        public static RoutedUICommand CopyF8 {
            get { return copyF8; }
        }
        public static RoutedUICommand RenameF2 {
            get { return renameF2; }
        }


        public static RoutedUICommand OwnerDefinedMask {
            get { return ownerDefinedMask; }
        }

        public static RoutedUICommand ShowAllFile {
            get { return showAllFile; }
        }

        

        public static RoutedUICommand SelectAll {
            get { return selectall; }
        }

        public static RoutedUICommand DeleteTab {
            get { return deleteTab; }
        }


        public static RoutedUICommand NewRegister {
            get { return newRegister; }
        }

        public static RoutedUICommand NewRegisterWithPath {
            get { return newRegisterWithPath; }
        }



        public static RoutedUICommand GoToTopFolder {
            get { return goToTopFolder; }
        }
        public static RoutedUICommand GoToRoot {
            get { return goToRoot; }
        }

        public static RoutedUICommand DosEbene {
            get { return dosEbene; }
        }

        public static RoutedUICommand NewInstanz {
            get { return newInstanz; }
        }

        public static RoutedUICommand Close {
            get { return close; }
        }


        public static RoutedUICommand RunNotepad {
            get { return runNotepad; }
        }



        public static RoutedUICommand Options {
            get { return options; }
        }


        public static RoutedUICommand ProgInfo {
            get { return progInfo; }
        }

        public static RoutedUICommand LoadDrivesAgain {
            get { return loadDrivesAgain; }
        }

        public static RoutedUICommand RunEditor5000 {
            get { return runEditor5000; }
        }


        public static RoutedUICommand RunHexEditor {
            get { return runHexEditor; }
        }

    }
}
