using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.Windows.Input;


namespace FM6000_Listview{
    class MyEditorCommands {
        private static RoutedUICommand newFile;
        private static RoutedUICommand openFile;
        private static RoutedUICommand saveFile;
        private static RoutedUICommand saveAsFile;

        private static RoutedUICommand undo;
        private static RoutedUICommand redo;

        private static RoutedUICommand copy;
        private static RoutedUICommand paste;
        private static RoutedUICommand cut;
        private static RoutedUICommand selectall;
        private static RoutedUICommand delete;


        
        private static RoutedUICommand wordwrap;


        private static RoutedUICommand close;

        private static RoutedUICommand dosEbene;

        private static RoutedUICommand options;
        private static RoutedUICommand progInfo;


        static MyEditorCommands() {

            newFile = new RoutedUICommand("Neue Datei", "newFile", typeof(MyCommands));
            newFile.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control));


            openFile = new RoutedUICommand("ffnen einer Datei", "openFile", typeof(MyCommands));
            openFile.InputGestures.Add(new KeyGesture(Key.O, ModifierKeys.Control));

            saveFile = new RoutedUICommand("Speichern einer Datei", "saveFile", typeof(MyCommands));
            saveFile.InputGestures.Add(new KeyGesture(Key.S, ModifierKeys.Control));

            saveAsFile = new RoutedUICommand("Speichern unter", "saveAsFile", typeof(MyCommands));
            saveAsFile.InputGestures.Add(new KeyGesture(Key.F12, ModifierKeys.None));


            undo = new RoutedUICommand("Rckgngig (Undo)", "undo", typeof(MyCommands));
            undo.InputGestures.Add(new KeyGesture(Key.Z, ModifierKeys.Control));
            redo = new RoutedUICommand("Wiederholen", "redo", typeof(MyCommands));
            redo.InputGestures.Add(new KeyGesture(Key.Y, ModifierKeys.Control));

            copy = new RoutedUICommand("Kopieren", "Copy", typeof(MyCommands));
            copy.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Control));

            paste = new RoutedUICommand("Einfgen", "Paste", typeof(MyCommands));
            paste.InputGestures.Add(new KeyGesture(Key.V, ModifierKeys.Control));

            cut = new RoutedUICommand("Ausschneiden", "Cut", typeof(MyCommands));
            cut.InputGestures.Add(new KeyGesture(Key.X, ModifierKeys.Control));


            delete = new RoutedUICommand("Lschen", "delete", typeof(MyCommands));

            wordwrap = new RoutedUICommand("Zeilenumbruch (WordWrap)", "wordwrap", typeof(MyCommands));

            selectall = new RoutedUICommand("Alles markieren", "selectall", typeof(MyCommands));
            selectall.InputGestures.Add(new KeyGesture(Key.A, ModifierKeys.Control));


            close = new RoutedUICommand("Schlieen", "close", typeof(MyCommands));

            dosEbene = new RoutedUICommand("Dos-Ebene im aktuellen Verzeichnis", "dosEbene", typeof(MyCommands));
            dosEbene.InputGestures.Add(new KeyGesture(Key.D, ModifierKeys.Control));




            options = new RoutedUICommand("Optionen", "options", typeof(MyCommands));

            progInfo = new RoutedUICommand("Programm-Info", "progInfo", typeof(MyCommands));
        }



        public static RoutedUICommand NewFile {
            get { return newFile; }
        }

        public static RoutedUICommand OpenFile {
            get { return openFile; }
        }

        public static RoutedUICommand SaveFile {
            get { return saveFile; }
        }

        public static RoutedUICommand SaveAsFile {
            get { return saveAsFile; }
        }

        public static RoutedUICommand Undo {
            get { return undo; }
        }
        public static RoutedUICommand Redo {
            get { return redo; }
        }


        public static RoutedUICommand Copy {
            get { return copy; }
        }
        public static RoutedUICommand Paste {
            get { return paste; }
        }
        public static RoutedUICommand Cut {
            get { return cut; }
        }


        public static RoutedUICommand Delete {
            get { return delete; }
        }



        public static RoutedUICommand SelectAll {
            get { return selectall; }
        }



        public static RoutedUICommand Wordwrap {
            get { return wordwrap; }
        }



        public static RoutedUICommand DosEbene {
            get { return dosEbene; }
        }


        public static RoutedUICommand Close {
            get { return close; }
        }



        public static RoutedUICommand Options {
            get { return options; }
        }


        public static RoutedUICommand ProgInfo {
            get { return progInfo; }
        }
    }
}

