using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FM6000_Listview{
    class MyRegistry {

        private static int _menuSize = 14;
        private static int _treeSize = 14;
        private static int _listViewSize = 14;
        private static bool _focusEqualsActive = false;

        public static int MenuSize {
            set {
                if (value > 7) {
                    _menuSize = value;
                    Basis.WriteRegInt(Konstanten.C_REG_ADR, "MenuFontSize", _menuSize);
                }
            }
            get { return _menuSize; }
        }
        public static int TreeSize {
            set {
                if (value > 7) {
                    _treeSize = value;
                    Basis.WriteRegInt(Konstanten.C_REG_ADR, "TreeFontSize", _treeSize);
                }
            }
            get { return _treeSize; }
        }
        public static int ListViewSize {
            set {
                if (value > 7) {
                    _listViewSize = value;
                    Basis.WriteRegInt(Konstanten.C_REG_ADR, "ListViewSize", _listViewSize);
                }
            }
            get { return _listViewSize; }
        }

        public static void loadMyRegistry() {
            int size = Basis.ReadRegInt(Konstanten.C_REG_ADR, "MenuFontSize");
            if (size > 7) {
                _menuSize = size;
            }
            size = Basis.ReadRegInt(Konstanten.C_REG_ADR, "TreeFontSize");
            if (size > 7) {
                _treeSize = size;
            }
            size = Basis.ReadRegInt(Konstanten.C_REG_ADR, "ListViewSize");
            if (size > 7) {
                _listViewSize = size;
            }
            int i = Basis.ReadRegInt(Konstanten.C_REG_ADR, "FocusEqualsActive");
            _focusEqualsActive = Basis.ReadRegInt(Konstanten.C_REG_ADR, "FocusEqualsActive") == 1;
        }

        public static bool FocusEqualsActive {
            set {
                _focusEqualsActive = value;
                if (_focusEqualsActive)
                    Basis.WriteRegInt(Konstanten.C_REG_ADR, "FocusEqualsActive", 1);
                else
                    Basis.WriteRegInt(Konstanten.C_REG_ADR, "FocusEqualsActive", 0);

            }
            get {
                return _focusEqualsActive;
            }
        }

    }
}
