using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Controls;
using System.Windows;


using System.Windows.Input;
using System.IO;
using System.Windows.Media;
using System.Windows.Threading;

namespace FM6000_Listview{
    class MyTextBox : DockPanel {

        public TextBox _editor;
        // private Panel panelLabels;
        WrapPanel _wrapPanel;
        private Label lRowNr;
        private Label lColumnNr;
        private Label lDatei;

        private FileSystemWatcher _fsw;

        private String _filename = "";


        private Boolean _modified = false;


        String search = "";
        Boolean ignoreCase = false;
        int position = 0;


        public String Filename {
            get { return _filename; }
            set {
                _filename = value;
                _fsw.Path = Basis.getPath(_filename);
                _fsw.Filter = _filename;
                _fsw.EnableRaisingEvents = true;
                lDatei.Content = _filename;
            }
        }

        public String Search {
            set {
                search = value;
                position = 0;  // sicherheit
            }
        }
        public Boolean IgnoreCase {
            set {
                ignoreCase = value;
                position = 0;
            }
        }


        public Boolean Modified {
            get { return _modified; }
            set { _modified = value; }
        }


        public Boolean WordWrap {
            get { return _editor.TextWrapping == TextWrapping.Wrap; }
            set {
                if (value)
                    _editor.TextWrapping = TextWrapping.Wrap;
                else
                    _editor.TextWrapping = TextWrapping.NoWrap;
            }
        }
        public Boolean Spell {
            get { return _editor.SpellCheck.IsEnabled; }
            set {
                _editor.SpellCheck.IsEnabled = value;
            }
        }


        public String Text {
            get {
                return _editor.Text;
            }
            set { _editor.Text = value; }
        }


        public void setFontsize(int size) {
            _editor.FontSize = size;
            lRowNr.FontSize = size;
            lColumnNr.FontSize = size;
            lDatei.FontSize = size;
        }


        public MyTextBox() {

            //this.Background = System.Windows.Media.Brushes.Red;

            this.LastChildFill = true;

            this.HorizontalAlignment = HorizontalAlignment.Stretch;
            this.VerticalAlignment = VerticalAlignment.Stretch;

            _editor = new TextBox();
            this._editor.TextWrapping = TextWrapping.Wrap;
            this._editor.AcceptsReturn = true;
            this._editor.AcceptsTab = true;
            this._editor.HorizontalScrollBarVisibility = ScrollBarVisibility.Visible;
            this._editor.VerticalScrollBarVisibility = ScrollBarVisibility.Visible;
            _editor.TextWrapping = TextWrapping.NoWrap;

            _editor.SpellCheck.IsEnabled = false;
            // CustomDictionaries dir = new CustomDictionaries();
            //  _editor.SpellCheck.CustomDictionaries
            // _editor.Language = Language.
            /*

    IList dictionaries = SpellCheck.GetCustomDictionaries(richTextBox1);

    // customwords2.lex is included as a resource file
    dictionaries.Add(new Uri(@"pack://application:,,,/WPFCustomDictionary;component/customwords2.lex"));
             
<RichTextBox FontSize="24" SpellCheck.IsEnabled="true" >
            <SpellCheck.CustomDictionaries>
                  <sys:Uri>Dictionary1.lex</sys:Uri>
                  <sys1:Uri>\\dictServer\Dictionary3.txt</sys1:Uri>          
            </SpellCheck.CustomDictionaries>
            <FlowDocument>
                  <Paragraph>Some Names: Zorig Lester </Paragraph>
                  <Paragraph>Misspelled: Zorg BlahBlah </Paragraph>
            </FlowDocument>
      </RichTextBox>
             * 
             */
            _wrapPanel = new WrapPanel();

            lRowNr = new Label();
            lRowNr.Content = "Zeilennr";
            lDatei = new Label();
            lDatei.Content = "Datei: ";

            lColumnNr = new Label();
            lColumnNr.Content = "Spalte";

            lRowNr.FontSize = 12;
            lColumnNr.FontSize = 12;
            lDatei.FontSize = 12;



            lRowNr.Margin = new Thickness(0, 0, 10, 0);  // left top right Bottom
            lColumnNr.Margin = new Thickness(0, 0, 10, 0);  // left top right Bottom

            _wrapPanel.HorizontalAlignment = HorizontalAlignment.Left;
            _wrapPanel.Children.Add(lRowNr);
            _wrapPanel.Children.Add(lColumnNr);
            _wrapPanel.Children.Add(lDatei);

            DockPanel dockpanel = new DockPanel();
            dockpanel.LastChildFill = true;

            DockPanel.SetDock(_wrapPanel, Dock.Bottom);
            DockPanel.SetDock(this._editor, Dock.Top);
            dockpanel.Children.Add(_wrapPanel);
            dockpanel.Children.Add(_editor);


            this._editor.FontSize = 14;
            this._editor.FontFamily = new System.Windows.Media.FontFamily("Courier New");

            // this._editor.MaxLength = 327670;


            _editor.TextChanged += textBox1_TextChanged;
            _editor.KeyDown += textBox1_KeyDown;

            this.Children.Add(dockpanel);
            _fsw = new FileSystemWatcher();
            _fsw.EnableRaisingEvents = false;
            // Events definieren
            _fsw.Changed += new FileSystemEventHandler(FSW_Changed);
            //_fsw.Created += new FileSystemEventHandler(FSW_Created);
            //_fsw.Deleted += new FileSystemEventHandler(FSW_Deleted);
            //_fsw.Renamed += new RenamedEventHandler(FSW_Renamed);
            setTimer();
        }

        private void setTimer() {
            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            // dispatcherTimer.Interval = new TimeSpan(0, 0, 1);  // hour, min, sec, ms
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(250);

            dispatcherTimer.Start();
        }

        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            setLineNummer();
            CommandManager.InvalidateRequerySuggested();
        }

        public void setLineNummer() {
            int charIndex = _editor.CaretIndex;
            int lineindex = (_editor.GetLineIndexFromCharacterIndex(charIndex) + 1);
            int index_aktLine = _editor.GetCharacterIndexFromLineIndex(lineindex - 1);
            this.lRowNr.Content = "Zl: " + lineindex;
            int columnCount = _editor.SelectionStart - index_aktLine + 1;
            this.lColumnNr.Content = "Sp: " + columnCount;
        }


        private void textBox1_KeyDown(object sender, KeyEventArgs e) {
            //setLineNummer();  // Probleme mit dem Cursor
        }



        private void textBox1_TextChanged(object sender, TextChangedEventArgs e) {
            _modified = true;
            //setLineNummer();
        }


        public void redoClick() {
            _editor.Redo();
        }
        public void undoClick() {
            _editor.Undo();
        }


        public void loadFile(String filename) {
            // wird auch vom Filewatcher aufgerufen, asynchron
            if (!_filename.Equals(filename) && _filename.Length > 0 && _modified) {
                MessageBoxResult res = Basis.readYesNoCancel("Sollen die nderungen gespeichert werden?" +
                      "Datei:\r\n" + _filename, "Programm beenden");
                switch (res) {
                    case MessageBoxResult.Yes: SaveFile();
                        break;
                    case MessageBoxResult.No:
                        break;
                    case MessageBoxResult.Cancel: return;
                }
            }

            if (File.Exists(filename)) {
                String path, name, ext;

                Basis.getPathNameExt(filename, out path, out name, out ext);
                _editor.Text = File.ReadAllText(filename);
                _filename = filename;
                _fsw.Path = Basis.getPath(filename);
                _fsw.Filter = Basis.getFilename(filename);  //  name + "." + ext;   // name + "*." + ext;
                _fsw.EnableRaisingEvents = true;
                lDatei.Content = _filename;
            }
        }
        void FSW_Renamed(object sender, RenamedEventArgs e) {
            filewatch();
        }
        void FSW_Deleted(object sender, FileSystemEventArgs e) {
            filewatch();
        }
        void FSW_Created(object sender, FileSystemEventArgs e) {
            filewatch();
        }
        void FSW_Changed(object sender, FileSystemEventArgs e) {
            filewatch();
        }

        delegate void loadAgainCallback();

        private void filewatch() {
            Application.Current.Dispatcher.Invoke(new Action(() => { loadAgain(); }));
        }

        public void loadAgain() {
            if (Basis.readYesNo("Die aktuelle Datei wurde auerhalb des Editors verndert\r\n" +
                "Soll sie neugeladen werden?", "Neu Laden der Datei")) {
                loadFile(_filename);
            }
        }

        public void NewFile() {
            _editor.Text = "";
            _filename = "";
            _fsw.EnableRaisingEvents = false;
            lDatei.Content = "";
        }


        public void SaveFile() {
            if (_filename.Length > 0) {
                File.WriteAllText(_filename, _editor.Text);
            }
        }

        public void Undo() {
            _editor.Undo();
        }
        public void Redo() {
            _editor.Redo();
        }

        public void Delete() {
            _editor.SelectedText = "";  // www
        }


        public void Copy() {
            _editor.Copy();
        }
        public void Cut() {
            _editor.Cut();
        }

        public void Paste() {
            _editor.Paste();
        }

        public void SelectAll() {
            _editor.SelectAll();
        }

        public void replaceText(String search, String replace, bool ignoreCase) {
            //int position = 0;
            //int index;
            _editor.Text = _editor.Text.Replace(search, replace);

            //this.search = search;
            //this.ignoreCase = ignoreCase;
            //position = 0;
            //int index;
            //if (this.ignoreCase)
            //    index = _editor.Text.IndexOf(search, position, StringComparison.OrdinalIgnoreCase);
            //else
            //    index = _editor.Text.IndexOf(search, position);
            //position = index + 1;
            //if (index > 0) {
            //    _editor.Select(index, search.Length);
            //    _editor.SelectionStart = index;
            //    // gescrollt wird alleine
            //    // editor.ScrollToLine( basis.getLinenr(index, editor.Text) );
            //    //editor.ScrollToHorizontalOffset(                
            //}
            //else {
            //    MessageBox.Show("Die Suche war nicht erfolgreich.\r\nSuchwert: " + search,
            //        "Suchen", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            //}
        }

        public void searchText(String search, Boolean ignoreCase) {
            this.search = search;
            this.ignoreCase = ignoreCase;
            position = 0;
            int index;
            if (this.ignoreCase)
                index = _editor.Text.IndexOf(search, position, StringComparison.OrdinalIgnoreCase);
            else
                index = _editor.Text.IndexOf(search, position);
            position = index + 1;
            if (index > 0) {
                _editor.Select(index, search.Length);
                _editor.SelectionStart = index;
                // gescrollt wird alleine
                // editor.ScrollToLine( basis.getLinenr(index, editor.Text) );
                //editor.ScrollToHorizontalOffset(                
            }
            else {
                MessageBox.Show("Die Suche war nicht erfolgreich.\r\nSuchwert: " + search,
                    "Suchen", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            }
        }

        public void SearchAgain() {
            int index;
            if (this.ignoreCase)
                index = _editor.Text.IndexOf(search, position, StringComparison.OrdinalIgnoreCase);
            else
                index = _editor.Text.IndexOf(search, position);
            position = index + 1;
            if (index > 0) {
                _editor.Select(index, search.Length);
                _editor.SelectionStart = index;
                // gescrollt wird alleine
                // editor.ScrollToLine( basis.getLinenr(index, editor.Text) );
                //editor.ScrollToHorizontalOffset(                
            }
        }

        public void prettyPrint() {
            //_editor.Text = output.ToString();
            //modified = true;
        }  // prettyPrint

        private String getTabs(int tablength) {
            String sErg = "";
            for (int i = 0; i < tablength; i++) {
                sErg += "\t";
            }
            return sErg;
        }


    }
}
