using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FM6000_Listview{
    /// <summary>
    /// Interaktionslogik fr RenameWindow.xaml
    /// </summary>
    public partial class RenameWindow : Window {
        private String von;
        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }

        public RenameWindow(Window parent, String von, bool dir) {
            InitializeComponent();
            this.von = von;
            if (dir)
                labelTitel.Content = "Umbenennen eines Direktories";
            else
                labelTitel.Content = "Umbenennen einer Datei";
            this.Owner = parent;  // Important, because CenterOwner            
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tVon.Text = von;
            tBis.Text = von;
            tBis.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            String newFile = tBis.Text.Trim();
            if (Basis.CheckDateinamen(newFile)) {
                if (newFile.Equals(tVon.Text.Trim())) {
                    Basis.ErrorMsg("Der neue Name muss sich von Original unterscheiden", "Hinweis");
                }
                else {
                    retcode = true;
                    Close();
                }
            }
            else {
                Basis.ErrorMsg("Der neue Name ist nicht gltig", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
        }


    }
}
