﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Diagnostics;
using System.ComponentModel;
using System.Collections;

using System.IO;
using System.Collections.ObjectModel;
using System.Threading;
using System.Windows.Threading;


namespace FM6000_Listview {
    /// <summary>
    /// Interaction logic for UListView.xaml
    /// </summary>
    public partial class UListView : UserControl {

        private DispatcherTimer dispatcherTimer = new DispatcherTimer();
        private bool isfswMessage = false;

        private Middleware _middleware = Middleware.getInstance();
        private Window _parent;
        private IFileManager _parentClass;

        // private List<FileItem> _fileliste = new List<FileItem>();
        private ObservableCollection<FileItem> _fileliste = new ObservableCollection<FileItem>();

        private char _abc = ' ';  // for the search modus
        private int _abcIndex = -1;
        private bool _abcChange = false;

        bool systemhidden = false;

        private FileSystemWatcher _fsw;

        private String _actualPath = "";

        private bool _left = false;


        public String ActualPath {
            get { return _actualPath; }
            set {
                if (value.Length > 0) {
                    _actualPath = value;
                    if (_actualPath.Equals(Konstanten.C_TOP_DIR))
                        listViewPath.Text = "";
                    else
                        listViewPath.Text = _actualPath;
                    showFilesInListView(_actualPath);
                    setFileWatcher(_actualPath);
                    _tabitem.Title = Basis.HeaderFolder(_actualPath);
                    TabItemIsActiv();
                }
                else {
                    _fsw.EnableRaisingEvents = false;
                }
            }
        }


        TabControl _tabControl = null;
        ITabControlManager _parentTabcontrol = null;
        private MyTabItem _tabitem = null;

        private MenuItem _mnMainProg = null;
        private MenuItem _mnMainFavoriten = null;

        private DelegateManager.setActiveRegister _setActiveReg;

        public Middleware.Masken _aktmask = Middleware.Masken.Stern;
        public String _OwnerDefined = ""; // variable for the mask, samples:  java;cs;pas

        ContextMenu _fileTable_ctm;

        public String OwnerDefined {
            set { _OwnerDefined = value; }
        }



        public ObservableCollection<FileItem> Fileliste {
            get { return _fileliste; }
        }

        public UListView() {
            InitializeComponent();

        }
        
        public void init(Window parent, ITabControlManager parentTabcontrol, bool left, TabControl tabControl, MyTabItem tabitem, String path, DelegateManager.setActiveRegister sFP) {
            setGUI();
            //_im_dir = im_dir;
            //_im_file = im_file;
            _setActiveReg = sFP;
            _parent = parent;
            _parentClass = (IFileManager)parent;
            _tabControl = tabControl;
            _parentTabcontrol = parentTabcontrol;
            _tabitem = tabitem;
            _left = left;
            ActualPath = path;
            

            _fileTable_ctm = new ContextMenu();
            this.ContextMenu = _fileTable_ctm;


            _mnMainProg = new MenuItem();
            _mnMainProg.Header = "Eigene Programme";
            _mnMainProg.Tag = null;
            _fileTable_ctm.Items.Add(_mnMainProg);
            _fileTable_ctm.Items.Add(new Separator());

            _mnMainFavoriten = new MenuItem();
            _mnMainFavoriten.Header = "Wechsel zu Favoriten";
            _mnMainFavoriten.Tag = null;
            _fileTable_ctm.Items.Add(_mnMainFavoriten);

            _fileTable_ctm.Items.Add(new Separator());



            MenuItem mn = new MenuItem();
            mn.Header = "Ausschneiden";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += cut_Click;

            mn = new MenuItem();
            mn.Header = "Kopieren";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += copy_Click;

            mn = new MenuItem();
            mn.Header = "Löschen";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += delete_Click;

            mn = new MenuItem();
            mn.Header = "Einfügen";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += paste_Click;

            _fileTable_ctm.Items.Add(new Separator());


            mn = new MenuItem();
            mn.Header = "Laufswerks-Informationen";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += drive_info_Click;

            _fileTable_ctm.Items.Add(new Separator());

            mn = new MenuItem();
            mn.Header = "Read files with System, Hidden";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += systemhidden_Click;

            _fileTable_ctm.Items.Add(new Separator());

            mn = new MenuItem();
            mn.Header = "Eigenschaften";
            mn.Tag = null;
            _fileTable_ctm.Items.Add(mn);
            mn.Click += property_Click;



            setContextMenu();
            this.MouseLeftButtonDown += filelist_Click;

            this.KeyDown += Window_KeyDown;

             // IsSynchronizedWithCurrentItem="True"
			// 	  local:ListViewSorter.IsListviewSortable="True"
            listView1.IsSynchronizedWithCurrentItem = true;
            

            listView1.ItemsSource = _fileliste;

            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            // dispatcherTimer.Interval = new TimeSpan(0, 0, 1);  // hour, min, sec, ms
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(500);

            dispatcherTimer.Start();

        }

        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            CommandManager.InvalidateRequerySuggested();
            if (isfswMessage) {
                filewatch();
                isfswMessage = false;
            } // if
            setDrives();

        }

        private void cbDrivelist_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            if (cbDrivelist.SelectedIndex>=0) {
                String drive = ((String)cbDrivelist.SelectedItem).Substring(0, 3);  // C:\\
                if (Directory.Exists(drive)) {
                    showFilesInListView(drive);
                    }
                cbDrivelist.SelectedIndex = -1;
            }
        }

        private void setDrives() {
            DriveInfo[] drives = DriveInfo.GetDrives();
            if (drives.Length != cbDrivelist.Items.Count) {
                cbDrivelist.Items.Clear();
                foreach (DriveInfo drv in drives) {

                    switch (drv.DriveType) {
                        case DriveType.CDRom:
                            cbDrivelist.Items.Add(drv.Name + " CD/DVD");
                            break;
                        case DriveType.Fixed:
                            cbDrivelist.Items.Add(drv.Name + " Festplatte");
                            break;
                        case DriveType.Network:
                            cbDrivelist.Items.Add(drv.Name + " Netzwerk");
                            break;
                        case DriveType.Ram:
                            cbDrivelist.Items.Add(drv.Name + " RAM");
                            break;
                        case DriveType.Removable:
                            cbDrivelist.Items.Add(drv.Name + " USB");
                            break;
                        case DriveType.Unknown:
                            cbDrivelist.Items.Add(drv.Name + " ??");
                            break;
                    }
                }
            }  // if
        }


        private void filelist_Click(object sender, RoutedEventArgs e) {
            // Basis.ErrorMsg("111", "click");
            this.Focus();
            TabItemIsActiv();
        }

        // KeyDown="Window_KeyDown"
        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Delete)) {
                if (Keyboard.IsKeyDown(Key.LeftShift) || Keyboard.IsKeyDown(Key.RightShift)) {
                    this.DeleteFiles(false);
                }
                else {
                    this.DeleteFiles(true);
                }
                e.Handled = true;
                return;
            }

            // D1 = Alt+1   D1 = Alt+2
            Key[] keys = { Key.D1, Key.D2, Key.D3, Key.D4, Key.D5, Key.D6, Key.D7, Key.D8, Key.D9 };
            if (Keyboard.IsKeyDown(Key.LeftAlt)) {
                if (Keyboard.IsKeyDown(Key.Enter)) {
                    // fileinfo
                    fileProperty();
                    e.Handled = true;
                    return;
                }

                // Unbereit Problem
                try {
                    DriveInfo[] drives = DriveInfo.GetDrives();
                    for (int i = 0; i < drives.Length; i++) {
                        if (Keyboard.IsKeyDown(keys[i])) {
                            if (drives[i].IsReady) {
                                ActualPath = drives[i].RootDirectory.ToString();
                                e.Handled = true;
                                return;
                            }
                        }
                    }
                }
                catch (Exception e1) {
                }
            }
            if (Keyboard.IsKeyDown(Key.Enter)) {
                fileTable_MouseDoubleClick();
                e.Handled = true;
                return;
            }
            if (Keyboard.IsKeyDown(Key.Insert)) {
                if (Keyboard.IsKeyDown(Key.LeftShift) || Keyboard.IsKeyDown(Key.RightShift)) {
                    this.Paste();
                    e.Handled = true;
                    return;
                }
            }
            if (Keyboard.IsKeyDown(Key.Insert)) {
                if (Keyboard.IsKeyDown(Key.LeftCtrl) || Keyboard.IsKeyDown(Key.RightCtrl)) {
                    this.Copy();
                    e.Handled = true;
                    return;
                }
            }
            if (!Keyboard.IsKeyDown(Key.LeftShift) && !Keyboard.IsKeyDown(Key.RightShift) &&
                !Keyboard.IsKeyDown(Key.LeftCtrl) && !Keyboard.IsKeyDown(Key.RightCtrl) &&
                !Keyboard.IsKeyDown(Key.LeftAlt) && !Keyboard.IsKeyDown(Key.RightAlt) &&
                !Keyboard.IsKeyDown(Key.CapsLock)
                ) {
                    int key = (int)KeyInterop.VirtualKeyFromKey(e.Key);
                    if (key >= 'A' && key < 'Z') {
                        Suche((char)key);
                    }
            }
        }  // keydown

        public void Suche(char abc) {
            if (_abc != abc) {
                _abcIndex = 0; // from start
            }
            FileItem fitem;
            for (int i = _abcIndex; i < this._fileliste.Count; i++) {
                fitem = _fileliste[i];
                char c = fitem.Filename.ToUpper()[0];
                if (c == abc) {
                    _abcChange = true;
                    listView1.SelectedIndex = i;
                    // scroll to the actual row
                    listView1.SelectedItem = listView1.Items.GetItemAt(i);
                    listView1.ScrollIntoView(listView1.SelectedItem);
                    // ListViewItem item = ItemContainerGenerator.ContainerFromItem(listView1.SelectedItem) as ListViewItem;
                    //item.Focus();
                    _abcIndex = i + 1;
                    _abc = abc;
                    _abcChange = false;
                    break;
                }
            } // for
        } // suche



        public void setContextMenu() {
            setContextMenu(Basis.getProgPath() + Konstanten.C_PROGS, _mnMainProg, true);
            setContextMenu(Basis.getProgPath() + Konstanten.C_FAVORITEN, _mnMainFavoriten, false);
        }

        public void setContextMenu(String filename, MenuItem mnMain, bool prog) {
            MenuItem mnItem;
            String filepath, name;
            mnMain.Items.Clear();
            if (File.Exists(filename)) {
                String[] items = File.ReadAllLines(filename);
                int i = 0;
                while (i < items.Length) {
                    if (items[i].Length > 0) {
                        mnItem = new MenuItem();
                        name = items[i];
                        i++;
                        filepath = items[i];
                        i++;
                        mnItem.Header = name;
                        mnItem.Tag = filepath;
                        mnMain.Items.Add(mnItem);
                        if (prog)
                            mnItem.Click += prog_ctm_Click;
                        else
                            mnItem.Click += favoriten_ctm_Click;
                    }
                    else {
                        i++;
                        i++;
                    }
                }
            }
        }


        private void favoriten_ctm_Click(object sender, EventArgs e) {
            MenuItem mnProg = (MenuItem)sender;
            String path = (String)mnProg.Tag;
            if (Directory.Exists(path)) {
                ActualPath = path;
            }
        }




        private void prog_ctm_Click(object sender, RoutedEventArgs e) {
            MenuItem mnProg = (MenuItem)sender;
            String program = (String)mnProg.Tag;
            if (File.Exists(program)) {                
                FileItem fitem = (FileItem)listView1.SelectedItem;
                if (fitem != null && !fitem.Directory) {
                    Process prog = new Process();
                    prog.StartInfo.FileName = "\"" + program + "\"";
                    prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                    prog.StartInfo.WorkingDirectory = ActualPath;
                    prog.Start();
                }
            }
        }




        private void cut_Click(object sender, RoutedEventArgs e) {
            this.Cut();
        }
        private void copy_Click(object sender, RoutedEventArgs e) {
            this.Copy();
        }
        private void bnCmdCopy_Click(object sender, RoutedEventArgs e) {
            this.Xcopy();
        }
        public void Xcopy() {
            // kopiere von links nach rechts     oder     rechts nach links
            UListView listview = _parentTabcontrol.getActiveListView(!_left);
            String destpath = listview.ActualPath;
            if (!destpath.EndsWith("\\")) destpath += "\\";
            //String srcpath = _actualPath;
            //if (!srcpath.EndsWith("\\")) srcpath += "\\";
            // xcopy *.*  e:\D   /s /I /V /C /E /J /R 

            String xcopyFilename;
            for (int i=1; i<10000; i++) {
                xcopyFilename = Basis.getProgPath() + "kopy"+i+".bat";
                if (!File.Exists(xcopyFilename)) {
                    break;
                }
            }

            StringBuilder sb = new StringBuilder();
            foreach (FileItem fitem in listView1.SelectedItems) {                
                if (!fitem.Filename.Equals(Konstanten.C_TOP_DIR)) {
                    if (fitem.Directory) {
                        sb.Append("XCOPY ");
                        sb.Append("\"");
                        sb.Append(fitem.Fullname);
                        sb.Append("\"");
                        sb.Append("  ");
                        sb.Append("\"");
                        sb.Append(destpath);
                        sb.Append(fitem.Filename);
                        sb.Append("\"");
                        sb.AppendLine("   /Y /S /I /V /C /E /J /R");

                    }
                    else {
                        sb.Append("COPY ");
                        sb.Append("\"");
                        sb.Append(fitem.Fullname);
                        sb.Append("\"");
                        sb.Append("  ");
                        sb.Append(destpath);
                        sb.Append("\"");
                        sb.Append(fitem.Filename);
                        sb.Append("\"");
                        sb.AppendLine("   /Y /V ");
                    }
                }
            }
            /*
System.Text.Encoding.ASCII
System.Text.Encoding.BigEndianUnicode
System.Text.Encoding.Unicode
System.Text.Encoding.UTF32
System.Text.Encoding.UTF7 
System.Text.Encoding.UTF8
Encoding.GetEncoding( 850): 
Encoding.GetEncoding( 437):              */
            // 850, 437, System.Text.Encoding.Unicode, UTF8, UTF7, UTF32, Encoding.GetEncoding("ISO-8859-1")
            File.WriteAllText(Basis.getProgPath() + "kopy.bat",sb.ToString(), Encoding.GetEncoding(850));

            // String cmd = "/c  XCOPY " + srcpath + "*.*  " + destpath + "   /Y /s /I /V /C /E /J /R";
            String cmd = "/c  "+Basis.getProgPath() + "kopy.bat";
            Process Prog = new Process();
            Prog.StartInfo.FileName = "CMD.exe";
            Prog.StartInfo.Arguments = cmd;
            // Prog.StartInfo.WorkingDirectory = _actualDirectory;
            Prog.Start();
        }


        private void delete_Click(object sender, RoutedEventArgs e) {
            this.DeleteFiles(true);
        }

        private void paste_Click(object sender, RoutedEventArgs e) {
            this.Paste();
        }



        private void drive_info_Click(object sender, RoutedEventArgs e) {
            _parentClass.showDriveInfo(ActualPath.Substring(0, 3));  // example: c:\\
        }


        private void fileProperty() {
            int index = listView1.SelectedIndex;
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null) {
                FProperty dialog = new FProperty(fitem.Fullname);
                dialog.ShowDialog();
            }
        }

        private void property_Click(object sender, RoutedEventArgs e) {
            fileProperty();
        }

        
        private void systemhidden_Click(object sender, RoutedEventArgs e) {
            systemhidden = true;
            showFilesInListView(_actualPath);
            systemhidden = false;
        }

        

        public void mysetFocus() {
            _setActiveReg(_left, _tabControl, _tabitem, this);
            listView1.Focus();
        }

        public void mylostFocus() {
            listView1.Background = Brushes.White;
            listView1.Foreground = Brushes.Black;
        }


        // set the active TabItem, the other TabItem "lost" the focus
        private void DockPanel_GotFocus(object sender, RoutedEventArgs e) {
            listView1.Background = Brushes.White; ; // (SolidColorBrush)(new BrushConverter().ConvertFrom("#FFF5FFFF"));  //  Brushes.LightCyan;
            listView1.Foreground = Brushes.Blue;
            _setActiveReg(_left, _tabControl, _tabitem, this);
        }


        public void TabItemIsActiv() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            _setActiveReg(_left, _tabControl, _tabitem, this);
            _parentClass.setActualMask(_aktmask, _OwnerDefined);
        }

        private void listView1_MouseDown(object sender, MouseButtonEventArgs e) {
            listView1.Focus();            
        } 



        private void fileTable_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            if (!_abcChange) {
                _abc = ' ';
            }
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null) {
                _setActiveReg(_left, _tabControl, _tabitem, this);
                if (_actualPath.Equals(Konstanten.C_TOP_DIR))
                    listViewPath.Text = "";
                else
                    listViewPath.Text = _actualPath;
                this.listViewFilename.Text = fitem.Fullname;
            }
        }


        public void fileTable_MouseDoubleClick() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null) {
                if (fitem.Directory) {
                    if (fitem.Filename.Equals(Konstanten.C_TOP_DIR)) {
                        DirectoryInfo directoryInfo;
                        if (_actualPath.EndsWith("\\"))
                            directoryInfo = new DirectoryInfo(_actualPath + "..");
                        else
                            directoryInfo = new DirectoryInfo(_actualPath + "\\..");
                        ActualPath = directoryInfo.FullName;
                    }
                    else {
                        ActualPath = (String)fitem.Fullname;
                    }
                    showFilesInListView(_actualPath);
                    _tabitem.Title = Basis.HeaderFolder(_actualPath);
                }
                else {
                    // if USB-Sticker is removed
                    if (File.Exists(fitem.Fullname)) {
                        try {
                            Process prog = new Process();
                            prog.StartInfo.FileName = fitem.Fullname;   // C:\\Daten\test.txt
                            prog.StartInfo.Arguments = "";
                            prog.StartInfo.WorkingDirectory = _actualPath;
                            prog.Start();
                        }
                        catch (Exception e) {
                            Basis.ErrorMsg("Fehler beim Starten\r\n" + e, "Fehler");
                        }
                    }
                }
            }
        }

        private void fileTable_MouseDoubleClick(object sender, MouseButtonEventArgs e) {
            fileTable_MouseDoubleClick();
        }

        // listView1
        BindingListCollectionView blcv;
        GridViewColumnHeader _lastHeaderClicked = null; // wich column was the last click
        ListSortDirection _lastDirection = ListSortDirection.Ascending;

        private void ColumnHeader_Click(object sender, RoutedEventArgs e) {
            ListSortDirection direction;

            GridViewColumnHeader headerClicked = e.OriginalSource as GridViewColumnHeader;  // Holen der Column
            // if the last click was the actual, then the sort a reverse
            if (headerClicked != null) {
                // CollectionView view = (CollectionView)CollectionViewSource.GetDefaultView(listView1.ItemsSource);

                ListCollectionView view = (ListCollectionView)CollectionViewSource.GetDefaultView(listView1.ItemsSource);

                if (headerClicked.Role != GridViewColumnHeaderRole.Padding) {
                    if (headerClicked != _lastHeaderClicked) {
                        if (headerClicked.Column.Header.Equals("Letztes Schreiben"))
                            direction = ListSortDirection.Descending;
                        else
                            direction = ListSortDirection.Ascending;
                        //view.SortDescriptions.Clear();
                        //view.SortDescriptions.Add(new SortDescription(headerClicked.Column.Header.ToString(), direction));
                    }
                    else {
                        if (_lastDirection == ListSortDirection.Ascending) {
                            direction = ListSortDirection.Descending;
                        }
                        else {
                            direction = ListSortDirection.Ascending;
                        }
                        //view.SortDescriptions.Clear();
                        //view.SortDescriptions.Add(new SortDescription(headerClicked.Column.Header.ToString(), direction));
                    }

                    // FileItem
                    // view.CustomSort = FileItemComparer;
                    FileItem.direction = direction;
                    string sortBy = (headerClicked.Column.DisplayMemberBinding as Binding).Path.Path;
                    switch (sortBy) {
                        case "Filename": FileItem.sortType = FileItem.FileinfoTyp.Name; break;
                        case "Ext": FileItem.sortType = FileItem.FileinfoTyp.Ext; break;
                        case "StringSize": FileItem.sortType = FileItem.FileinfoTyp.Size; break;
                        case "LastTime": FileItem.sortType = FileItem.FileinfoTyp.LastTime; break;
                        default: return;  // image
                    }
                    view.CustomSort = new FileItemComparer();
                    listView1.Items.Refresh();


                    _lastHeaderClicked = headerClicked;
                    _lastDirection = direction;
                }
            } // if
        }

        private void Sort(string sortBy, ListSortDirection direction) {
            blcv.SortDescriptions.Clear();
            SortDescription sd = new SortDescription(sortBy, direction);
            blcv.SortDescriptions.Add(sd);
            blcv.Refresh();
        }




        private void setFileWatcher(String actualPath) {
            if (actualPath.Length > 0) {
                _fsw.Path = actualPath;
                _fsw.Filter = "*.*";
                _fsw.EnableRaisingEvents = true;
            }
        }  // setFileWatcher


        private void setGUI() {
            //MyCommandsListView cmd = new MyCommandsListView();
            //bnCopy.Command = cmd.Copy;
            //bnCut.Command = cmd.Cut;
            //bnDelete.Command = cmd.Delete;
            //bnPaste.Command = cmd.Paste;
            //bnF5.Command = cmd.LoadAgain;
            //bnMaskAll.Command = cmd.ShowAllFile;
            //bnRenameF2.Command = cmd.RenameF2;
            //bnCopyFileF8.Command = cmd.CopyF8;
            //bnGoToTopFolder.Command = cmd.GoToTopFolder;
            //bnToRoot.Command = cmd.GoToRoot;

            //CommandBindings.Add(new CommandBinding(cmd.Copy, CopyExecuted));
            //CommandBindings.Add(new CommandBinding(cmd.Paste, PasteExecuted));
            //CommandBindings.Add(new CommandBinding(cmd.Cut, CutExecuted));
            //CommandBindings.Add(new CommandBinding(cmd.Delete, DeleteExecuted));

            //CommandBindings.Add(new CommandBinding(cmd.CopyF8, CopyF8Executed));
            //CommandBindings.Add(new CommandBinding(cmd.RenameF2, RenameF2Executed));


            //CommandBindings.Add(new CommandBinding(cmd.GoToTopFolder, GoToTopFolderExecuted));
            //CommandBindings.Add(new CommandBinding(cmd.GoToRoot, GoToRootExecuted));
            //CommandBindings.Add(new CommandBinding(cmd.LoadAgain, LoadAgainExecuted));
            //CommandBindings.Add(new CommandBinding(cmd.ShowAllFile, ShowAllFileExecuted));
            

            this.AddHandler(GridViewColumnHeader.ClickEvent, new RoutedEventHandler(ColumnHeader_Click));

            listView1.SelectionChanged += new SelectionChangedEventHandler(fileTable_SelectionChanged);
            listView1.MouseDoubleClick += new MouseButtonEventHandler(fileTable_MouseDoubleClick);

            _fsw = new FileSystemWatcher();
            _fsw.EnableRaisingEvents = false;
            // Events definieren
            _fsw.Changed += new FileSystemEventHandler(FSW_Changed);
            _fsw.Created += new FileSystemEventHandler(FSW_Created);
            _fsw.Deleted += new FileSystemEventHandler(FSW_Deleted);
            _fsw.Renamed += new RenamedEventHandler(FSW_Renamed);

            setFavoriten();

        }  // setGUI


        public void setFavoriten() {
            MenuItem mn;
            String path = Basis.getProgPath();
            if (File.Exists(path + Konstanten.C_FAVORITEN)) {
                String[] items = File.ReadAllLines(path + Konstanten.C_FAVORITEN);
                int i = 0;
                bnFavoritenItems.Items.Clear();
                while (i < items.Length) {
                    if (items[i].Length > 0) {
                        if (!Directory.Exists(items[i + 1])) {
                            Basis.ErrorMsg("Das Verzeichnis ist nicht vorhanden\r\n" + items[i + 1], "Eintragen der Favoriten-Verzeichnisse");
                            i += 2;
                        }
                        else {
                            mn = new MenuItem();
                            mn.Header = items[i];
                            i++;
                            mn.Tag = items[i];
                            i++;
                            mn.Click += mnlkSetFavoriten_Click;
                            bnFavoritenItems.Items.Add(mn);
                        }
                    }
                    else {
                        i++;
                        i++;
                    }
                }
            }
            // bnFavoritenItems
        }

        private void mnlkSetFavoriten_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)sender;
            String path = (String)mn.Tag;
            if (Directory.Exists(path)) {
                ActualPath = path;
            }
        }


        void FSW_Renamed(object sender, RenamedEventArgs e) {
            isfswMessage = true;
        }
        void FSW_Deleted(object sender, FileSystemEventArgs e) {
            isfswMessage = true;
        }
        void FSW_Created(object sender, FileSystemEventArgs e) {
            isfswMessage = true;
        }
        void FSW_Changed(object sender, FileSystemEventArgs e) {
            isfswMessage = true;
        }

        delegate void showFilesInListViewCallback(string actualPath);

        private void filewatch() {
            Application.Current.Dispatcher.Invoke(new Action(() => { showFilesInListView(_actualPath); }));
        }

        private void showFilesInListView(String path) {
            if (path == null) {
                return; // Hauptpunkte à la Anwender, Favoriten, Laufwerke
            }
            if (!Directory.Exists(path)) {
                path = Basis.getProgPath();
                // Basis.ErrorMsg("path neu", "");
            }

            int index = listView1.SelectedIndex;

            // listView1.Items.Clear();
            listViewFilename.Text = "";
            _fileliste.Clear();
            _actualPath = path;
            FileItem fitem;

            this.BeginInit();
            FileItem selectfitem = null;
            if (_actualPath.Length > 3) {
                fitem = new FileItem(true);  // directory
                fitem.Fullname = Konstanten.C_TOP_DIR;
                fitem.Filename = Konstanten.C_TOP_DIR;
                fitem.Size = 0;
                fitem.Ext = "";
                fitem.IconUri = im_dir.Source; // imageimage
                _fileliste.Add(fitem);
                // listView1.Items.Add(fitem);
                selectfitem = fitem;
            }

            // at fist, get the subdirs
            String[] dirs = Directory.GetDirectories(path);
            foreach (String item in dirs) {
                DirectoryInfo dir = new DirectoryInfo(item);
                FileAttributes attribs = dir.Attributes;
                if ( systemhidden || ( (attribs & FileAttributes.Hidden) != FileAttributes.Hidden && (attribs & FileAttributes.System) != FileAttributes.System)) {
                    fitem = new FileItem(true);  // is directory
                    fitem.Fullname = dir.FullName;
                    fitem.Filename = dir.Name;
                    fitem.Size = 0;
                    fitem.Ext = "";
                    fitem.LastTime = dir.LastWriteTime;  // dir.LastWriteTime;
                    fitem.CreateTime = dir.LastWriteTime;
                    fitem.IconUri = im_dir.Source; // imageimage
                    _fileliste.Add(fitem);
                    // listView1.Items.Add(fitem);
                }
            }
            // next, get the files

            DirectoryInfo mainDir = new DirectoryInfo(_actualPath);
            // String[] files = Directory.GetFiles(path);
            String[] masken = Middleware.getMasks(_aktmask, _OwnerDefined);
            foreach (String maske in masken) {
                FileInfo[] files = mainDir.GetFiles(maske, SearchOption.TopDirectoryOnly);
                foreach (FileInfo file in files) {
                    String item = file.FullName;
                    FileInfo fi = new FileInfo(item);
                    // DateTime lastdate = fi.LastWriteTime     
                    FileAttributes attribs = fi.Attributes;
                    if (systemhidden || ((attribs & FileAttributes.Hidden) != FileAttributes.Hidden && (attribs & FileAttributes.System) != FileAttributes.System)) {
                        fitem = new FileItem(false);  // no directory
                        fitem.Fullname = fi.FullName;
                        fitem.Filename = fi.Name;
                        fitem.Ext = fi.Extension;
                        fitem.Size = fi.Length;
                        fitem.LastTime = fi.LastWriteTime; //  dir.LastWriteTime;  // dir.LastAccessTime;
                        fitem.CreateTime = fi.LastWriteTime;
                        fitem.IconUri = im_file.Source; // imageimage
                        _fileliste.Add(fitem);
                        // listView1.Items.Add(fitem);
                    }
                }
            }
            this.EndInit();

            this.Focus();
            listView1.Focus();

            if (index < listView1.Items.Count) {
                listView1.SelectedIndex=index;
            }
            else {
                if (listView1.Items.Count > 0) {
                    listView1.SelectedIndex = 0;
                }
            }
            TabItemIsActiv();
            // lMessage.Content = listView1.SelectedIndex + "";
        }  // showFilesinListView


        private void DeleteExecuted(object sender, ExecutedRoutedEventArgs e) {
            DeleteFiles(true);
        }
        public void DeleteFiles(bool recycleBin) {
            ThreadCopyDeleteMove.FileOperationType fileop;
            fileop = ThreadCopyDeleteMove.FileOperationType.FO_DELETE;
            String actionFileString = getSelectedFiles_Delete();
            if (actionFileString.Length > 0) {
                ThreadCopyDeleteMove tcopydelmov; 
                if (recycleBin)
                    tcopydelmov = new ThreadCopyDeleteMove(actionFileString, _actualPath, fileop, ThreadCopyDeleteMove.FileOperationFlags.FOF_ALLOWUNDO);
                else
                    tcopydelmov = new ThreadCopyDeleteMove(actionFileString, _actualPath, fileop, 0);
                Thread t = new Thread(tcopydelmov.run);
                t.Start();
                // showFilesInListView(_actualPath); // FileWatcher                
            }

        }  // deleteFiles


        private void CopyExecuted(object sender, ExecutedRoutedEventArgs e) {
            Copy();
        }
        public void Copy() {
            insertSelectedFiles(ThreadCopyDeleteMove.FileOperationType.FO_COPY);
        }

        private void PasteExecuted(object sender, ExecutedRoutedEventArgs e) {
            Paste();
        }
        public void Paste() {
            ThreadCopyDeleteMove.FileOperationType fileop;
            String actionFileString = "";

            int action = _middleware.getSelectedFilesFromRegistry(out actionFileString);
            switch (action) {
                case 1: fileop = ThreadCopyDeleteMove.FileOperationType.FO_MOVE; break;
                case 2: fileop = ThreadCopyDeleteMove.FileOperationType.FO_COPY; break;
                default: return;  // action=0
            }
            ThreadCopyDeleteMove tcopydelmov; 
            tcopydelmov = new ThreadCopyDeleteMove(actionFileString, _actualPath, fileop, ThreadCopyDeleteMove.FileOperationFlags.FOF_ALLOWUNDO);
            Thread t = new Thread(tcopydelmov.run);
            t.Start();

            // showFilesInListView(_actualPath);  // FileWatcher
        }  // Paste




        private void CutExecuted(object sender, ExecutedRoutedEventArgs e) {
            Cut();
        }
        public void Cut() {
            insertSelectedFiles(ThreadCopyDeleteMove.FileOperationType.FO_MOVE);
            showFilesInListView(_actualPath);
        }


        private void bnCopyFileF8_Click(object sender, RoutedEventArgs e) {
            CopyF8();
        }
        private void CopyF8Executed(object sender, ExecutedRoutedEventArgs e) {
            CopyF8();
        }
        private void bnRenameF2_Click(object sender, RoutedEventArgs e) {
            RenameF2();
        }
        private void RenameF2Executed(object sender, ExecutedRoutedEventArgs e) {
            RenameF2();
        }

        public void CopyF8() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null && !fitem.Directory) {
                String path;
                String filename;
                Basis.splitFilename(fitem.Fullname, out path, out filename);
                FCopyWindow dialog = new FCopyWindow(_parent, filename);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    String newFilename = dialog.tBis.Text.Trim();
                    if (newFilename.IndexOf(":\\") == -1) {
                        newFilename=path+newFilename;
                    }
                    if (File.Exists(newFilename)) {
                        File.Delete(newFilename);
                    }
                    System.IO.File.Copy(fitem.Fullname, newFilename);
                    showFilesInListView(_actualPath);
                }
            }
        }
        public void RenameF2() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null) {
                String path;
                String filename;
                Basis.splitFilename(fitem.Fullname, out path, out filename);
                FRenameWindow dialog = new FRenameWindow(_parent, filename, fitem.Directory);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    try {
                        String newfile = dialog.tBis.Text.Trim();
                        String newFilename;
                        if (newfile.IndexOf("\\") >= 0)
                            newFilename = newfile;
                        else
                            newFilename = path + newfile;
                        if (fitem.Directory) {
                            DirectoryInfo di = new DirectoryInfo(fitem.Fullname);

                            if (fitem.Fullname.ToLower().Equals(newFilename.ToLower())) {
                                //System.IO.File.Move(fitem.Fullname, "1234!!!!!!666");
                                //System.IO.File.Move("1234!!!!!!666", newFilename);

                                di.MoveTo(System.IO.Path.Combine(di.Parent.FullName, "1234!!!!!!666"));
                                di.MoveTo(System.IO.Path.Combine("1234!!!!!!666", newFilename));
                            }
                            else {
                                di.MoveTo(System.IO.Path.Combine(di.Parent.FullName, newFilename));
                            }


                            // di.MoveTo(System.IO.Path.Combine(di.Parent.FullName, newFilename));
                        }
                        else {
                            if (fitem.Fullname.ToLower().Equals(newFilename.ToLower())) {
                                System.IO.File.Move(fitem.Fullname, "1234!!!!!!666");
                                System.IO.File.Move("1234!!!!!!666", newFilename);
                            }
                            else {
                                System.IO.File.Move(fitem.Fullname, newFilename);
                            }
                        }
                        showFilesInListView(_actualPath);
                    }
                    catch (Exception e) {
                        Basis.ErrorMsg(e.ToString(), "Fehler beim Umbenennen");
                    }
                }
            }
        }


        private void GoToTopFolderExecuted(object sender, ExecutedRoutedEventArgs e) {
            GoToTopFolder();
        }
        private void bnGoToTopFolder_Click(object sender, RoutedEventArgs e) {
            GoToTopFolder();
        }
        public void GoToTopFolder() {
            if (_actualPath.Length > 3) {
                DirectoryInfo directoryInfo;
                if (_actualPath.EndsWith("\\"))
                    directoryInfo = new DirectoryInfo(_actualPath + "..");
                else
                    directoryInfo = new DirectoryInfo(_actualPath + "\\..");
                ActualPath = directoryInfo.FullName;
                showFilesInListView(_actualPath);
            }
        }
        private void bnToRoot_Click(object sender, RoutedEventArgs e) {
            GoToRoot();
        }
        private void GoToRootExecuted(object sender, ExecutedRoutedEventArgs e) {
            GoToRoot();
        }
        public void GoToRoot() {
            if (_actualPath.Length > 3) {
                ActualPath = _actualPath.Substring(0, 3);
                showFilesInListView(_actualPath);
            }
        }





        private void NewFolderExecuted(object sender, ExecutedRoutedEventArgs e) {
            NewFolder();
        }
        public void NewFolder() {
            if (!_actualPath.Equals("")) {
                String path = _actualPath;
                if (!path.EndsWith("\\")) path += "\\";
                FReadString dialog = new FReadString(_parent, "Neuer Ordner", "Ordnername");
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    String newDir = path + dialog.tInput.Text.Trim();
                    System.IO.Directory.CreateDirectory(newDir);
                    showFilesInListView(_actualPath);
                }
            }
        } // NewFolder

        public void setMask(Middleware.Masken mask) {
            _aktmask = mask;
            showFilesInListView(ActualPath);
        }

        private void mnlkMasks_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem) sender;
            _aktmask=Middleware.Masken.ownerdef;
            _OwnerDefined = (String) mn.Header;
            showFilesInListView(ActualPath);
        }

        private void bnMaskAll_Click(object sender, RoutedEventArgs e) {
            setMask(Middleware.Masken.Stern);
        }
        private void ShowAllFileExecuted(object sender, ExecutedRoutedEventArgs e) {
            setMask(Middleware.Masken.Stern);
        }




        private void bnF5_Click(object sender, RoutedEventArgs e) {
            LoadAgain();
        }
        private void LoadAgainExecuted(object sender, ExecutedRoutedEventArgs e) {
            LoadAgain();
        }
        public void LoadAgain() {
            // insertDrives(_mainNodeDrives);
            if (!_actualPath.Equals("")) showFilesInListView(_actualPath);
        }




        private void insertSelectedFiles(ThreadCopyDeleteMove.FileOperationType action) {
            // System.Collections.ICollection liste = SelectedItems;
            if (listView1.SelectedItems.Count > 0) {
                ArrayList liste = new ArrayList();
                foreach (FileItem fitem in listView1.SelectedItems) {
                    if (!fitem.Filename.Equals(Konstanten.C_TOP_DIR)) {
                        liste.Add(fitem.Fullname);
                    }
                }
                _middleware.insertSelectedFiles(liste, action);
            }
            else {
                MessageBox.Show("Sie haben keine Dateien/Verzeichnisse ausgewählt", "Hinweis", MessageBoxButton.OK, MessageBoxImage.Information);
            }
        }  // insertSelectedFiles

        public void ChangeExtention() {
            if (listView1.SelectedItems.Count > 0) {
                ArrayList liste = new ArrayList();
                foreach (FileItem fitem in listView1.SelectedItems) {
                    if (!fitem.Directory) {
                        liste.Add(fitem);
                    }
                }
                if (liste.Count > 0) {
                    FReadString dialog = new FReadString(_parent, "Umbennen von Dateierweiterungen","Neue Erweiterung");
                    dialog.ShowDialog();
                    if (dialog.Retcode) {
                        String newExtention = dialog.Input;
                        foreach (FileItem fitem in liste) {
                            fitem.ChangeExtention(newExtention);
                         //   splitFilename(fitem.Fullname, out path, out String filename);
                        }
                    }
                }
                else {
                    MessageBox.Show("Sie haben keine Dateien ausgewählt", "Hinweis", MessageBoxButton.OK, MessageBoxImage.Information);
                }
                // _middleware.insertSelectedFiles(liste, action);
            }
            else {
                MessageBox.Show("Sie haben keine Dateien ausgewählt", "Hinweis", MessageBoxButton.OK, MessageBoxImage.Information);
            }
        }  // changeFileExtention

        public void RenameWithNumbers() {
            if (listView1.SelectedItems.Count > 0) {
                ArrayList liste = new ArrayList();
                foreach (FileItem fitem in listView1.SelectedItems) {
                    if (!fitem.Directory) {
                        liste.Add(fitem);
                    }
                }
                if (liste.Count > 0) {
                    FReadRenameWithNumbers dialog = new FReadRenameWithNumbers(_parent);
                    dialog.ShowDialog();
                    if (dialog.Retcode) {
                        String sNumbers;
                        String prefix = dialog.Prefix;
                        int numbers = dialog.CountNumbers;
                        StringBuilder sb = new StringBuilder();
                        for (int i = 0; i < numbers; i++) {
                            sb.Append("0");
                        }
                        for (int i = 0; i < liste.Count;i++ ) {
                            FileItem fitem = (FileItem)liste[i];
                            sNumbers = (i + 1).ToString(sb.ToString());
                            fitem.RenameWithNumbers(prefix, sNumbers);
                        }
                    }
                }
                else {
                    MessageBox.Show("Sie haben keine Dateien ausgewählt", "Hinweis", MessageBoxButton.OK, MessageBoxImage.Information);
                }
                // _middleware.insertSelectedFiles(liste, action);
            }
            else {
                MessageBox.Show("Sie haben keine Dateien ausgewählt", "Hinweis", MessageBoxButton.OK, MessageBoxImage.Information);
            }
        }

        private String getSelectedFiles_Delete() {
            System.Collections.ICollection liste = listView1.SelectedItems;
            if (liste.Count > 0) {
                // foreach (ListViewItem selectedItem in fileTable.SelectedItems) {
                StringBuilder files = new StringBuilder();
                foreach (FileItem fitem in listView1.SelectedItems) {
                    if (!fitem.Filename.Equals(Konstanten.C_TOP_DIR)) {
                        files.Append(fitem.Fullname).Append("\0");
                    }
                }
                return files.ToString();
            }
            else {
                MessageBox.Show("Sie haben keine Dateien/Verzeichnisse ausgewählt", "Hinweis", MessageBoxButton.OK, MessageBoxImage.Information);
                return "";
            }
        }  // getSelectedFiles_Delete

        private void listView1_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            int n = 0;
            long summe = 0;
            foreach (FileItem fitem in listView1.SelectedItems) {
                if (!fitem.Filename.Equals(Konstanten.C_TOP_DIR)) {
                    n++;
                    if (!fitem.Directory) summe += fitem.Size;
                }
            }
            if (summe == 0)
                lMessage.Content = " Es wurden " + n + " Einträge markiert";
            else
                lMessage.Content = " Es wurden " + n + " Einträge markiert, Summe: " + Basis.Best_KB(summe); ;
        }   



        public void SelectAllItems() {
            listView1.SelectAll();
        }


        public void RunNotepad() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null && !fitem.Directory) {
                Process prog = new Process();
                prog.StartInfo.FileName = "notepad.exe";
                prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                prog.Start();
            }
        }

        public void RunHexEditor() {
            String program = Basis.getProgPath() + "Hexeditor.exe";
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null && !fitem.Directory) {
                if (File.Exists(program)) {
                    Process prog = new Process();
                    prog.StartInfo.FileName = program;
                    prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                    prog.Start();
                }
                else {
                    Basis.ErrorMsg("Der HexEditor ist nicht vorhanden\r\n" + program, "Fehler");
                }
            }
        }

        public void RunEditor5000() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null && !fitem.Directory) {
                Process prog = new Process();
                prog.StartInfo.FileName = Basis.getProgPath() + "Editor5000.exe";
                prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                prog.Start();
            }
        }

        public void DosEbene() {
            Process prog = new Process();
            prog.StartInfo.FileName = "CMD.exe";
            prog.StartInfo.Arguments = "";
            prog.StartInfo.WorkingDirectory = _actualPath;  // !!!
            prog.Start();
        }


        public void Path2Clipboard() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null) {
                Clipboard.SetDataObject(fitem.Fullname);
            }
        }

        public void ShowAllFiles() {
            FileItem fitem = (FileItem)listView1.SelectedItem;
            if (fitem != null) {
                if (fitem.Directory) {
                    createFilesRekursiv(fitem.Fullname);
                }
            }
        }


        private void createFilesRekursiv(String dirFilename) {
            StringBuilder erg = new StringBuilder();

            long gesamtsumme = 0;
            long summe = 0;
            String lastdir = "";
            // this.Cursor = Cursors.Wait;
            Mouse.OverrideCursor = Cursors.Wait;
            try {
                String[] files = Directory.GetFiles(dirFilename, "*.*", SearchOption.AllDirectories);
                foreach (String filename in files) {
                    String path = Basis.getPath(filename);
                    if (lastdir.Equals("")) erg.Append(path + "\r\n");
                    if (!lastdir.Equals("") && !path.Equals(lastdir)) {
                        erg.Append("   Summe: " + Basis.Best_KB(summe) + ", " + Basis.Long_Str_Komma(summe) + " Bytes\r\n\r\n");
                        summe = 0;
                        erg.Append(path + "\r\n");
                    }
                    FileInfo fi = new FileInfo(filename);
                    summe += fi.Length;
                    gesamtsumme += fi.Length;
                    erg.Append("   " + Basis.getFilename(filename) + ", " + Basis.Best_KB(fi.Length) + "\r\n");
                    lastdir = path;
                }
                erg.Append("Summe: " + Basis.Best_KB(summe) + ", " + Basis.Long_Str_Komma(summe) + " Bytes\r\n\r\n");
                erg.Append("Gesamtsumme: " + Basis.Best_KB(gesamtsumme) + ", " + Basis.Long_Str_Komma(gesamtsumme) + " Bytes");
            }
            finally {
                Mouse.OverrideCursor = null;
            }
            // this.Cursor = Cursors.Arrow;


            FEditor dialog = new FEditor(erg.ToString());
            dialog.Show();
        }

        public void CompareFolders(String actualPath, ObservableCollection<FileItem> fileliste2) {
            List<FileItem> equal = new List<FileItem>();
            List<FileItem> sizeNotEqual1 = new List<FileItem>();
            List<FileItem> sizeNotEqual2 = new List<FileItem>();
            List<FileItem> timeNotEqual = new List<FileItem>();
            List<FileItem> notinListe1 = new List<FileItem>();
            List<FileItem> notinListe2 = new List<FileItem>();
            // _fileliste  mit fileliste2
            Mouse.OverrideCursor = Cursors.Wait;
            try {
                foreach (FileItem item1 in _fileliste) {
                    bool gefunden = false;
                    foreach (FileItem item2 in fileliste2) {
                        if (item1.Filename.Equals(item2.Filename)) {
                            gefunden = true;
                            if (item1.Size != item2.Size) {
                                sizeNotEqual1.Add(item1);
                                sizeNotEqual2.Add(item2);
                            }
                            else {
                                if (item1.LastTime != item2.LastTime) {
                                    timeNotEqual.Add(item1);
                                }
                                else {
                                    if (item1.Filename != Konstanten.C_TOP_DIR) {
                                        equal.Add(item1);
                                    }
                                }
                            }
                        }
                    }
                    if (!gefunden) {
                        notinListe2.Add(item1);
                    }
                }
                foreach (FileItem item2 in fileliste2) {
                    bool gefunden = false;
                    foreach (FileItem item1 in _fileliste) {
                        if (item2.Filename.Equals(item1.Filename)) {
                            gefunden = true;
                        }
                    }
                    if (!gefunden) {
                        notinListe1.Add(item2);
                    }
                }
            }
            finally {
                Mouse.OverrideCursor = null;
            }
            StringBuilder erg = new StringBuilder();
            erg.Append("Linke Liste:" + _actualPath + "\r\n");
            erg.Append("Rechte Liste:" + actualPath + "\r\n\r\n\r\n");


            if (notinListe2.Count > 0) {
                erg.Append("Dateien, die nur in linker Liste sind:\r\n");
                foreach (FileItem item in notinListe2) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, die nur in linker Liste sind.\r\n\r\n\r\n");
            }
            erg.Append("\r\n\r\n");
            if (notinListe1.Count > 0) {
                erg.Append("Dateien, die nur in rechter Liste sind:\r\n");
                foreach (FileItem item in notinListe1) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, die nur in rechter Liste sind.\r\n\r\n\r\n");
            }

            erg.Append("\r\n\r\n");
            if (sizeNotEqual1.Count > 0) {
                erg.Append("Dateien, deren Größe unterschiedlich ist:\r\n");
                for (int i = 0; i < sizeNotEqual1.Count; i++) {
                    FileItem item1 = sizeNotEqual1[i];
                    FileItem item2 = sizeNotEqual2[i];
                    erg.Append("  " + item1.Filename + ", " + Basis.Best_KB(item1.Size) + ", " + Basis.Best_KB(item2.Size) + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, deren Größe unterschiedlich ist.\r\n\r\n\r\n");
            }

            erg.Append("\r\n\r\n");
            if (timeNotEqual.Count > 0) {
                erg.Append("Dateien, deren Zeiten unterschiedlich sind:\r\n");
                foreach (FileItem item in timeNotEqual) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, deren Zeiten unterschiedlich sind.\r\n\r\n\r\n");
            }

            erg.Append("\r\n\r\n");
            if (equal.Count > 0) {
                erg.Append("Dateien, die in beiden Listen gleich sind:\r\n");
                foreach (FileItem item in equal) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, die in beiden Listen gleich sind.\r\n\r\n\r\n");
            }



            FEditor dialog = new FEditor(erg.ToString());
            dialog.Show();
        }// CompareFolders

    }
}
